using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.Common;
using System.Globalization;

namespace Anniversaires
{
 public partial class Form1 : Form
 {
  public Form1()
  {
   InitializeComponent();
  }
  DataSet oDS;
  string[] tMois;
  string[] tJours;
  private void Form1_Load(object sender, EventArgs e)
  {
   // ouvrir la base de donnes
   DbProviderFactory dbpf = DbProviderFactories.GetFactory("System.Data.OleDb");
   DbConnection oConn = dbpf.CreateConnection();
   oConn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=Anniversaires.mdb";
   DbDataAdapter oDA = dbpf.CreateDataAdapter();
   oDA.SelectCommand = oConn.CreateCommand();
   oDA.SelectCommand.CommandText = "SELECT * FROM DatesAnniversaires ORDER BY NOM";
   oDS = new DataSet();
   oDA.Fill(oDS);

   // tableau des noms de mois et des jours de la semaine
   tMois = CultureInfo.CurrentCulture.DateTimeFormat.MonthNames;
   tJours = CultureInfo.CurrentCulture.DateTimeFormat.DayNames;

   // remplir la bote combo des jours du mois
   for (int i = 1; i <= 31; i++) coJour.Items.Add(i); 

   // mme chose pour les mois
   for (int i=0; i<12; i++) coMois.Items.Add(tMois[i]); 

   // date du jour comme date par dfaut
   coJour.SelectedIndex = DateTime.Now.Day - 1;
   coMois.SelectedIndex = DateTime.Now.Month - 1;
  }

  private void bRechJourMois_Click(object sender, EventArgs e)
  {
   lbPers.Items.Clear();
   int N = oDS.Tables[0].Rows.Count;
   for (int i = 0; i < N; i++)
   {
    DateTime dt = (DateTime)oDS.Tables[0].Rows[i]["DN"];
    if (dt.Day == coJour.SelectedIndex+1 && dt.Month == coMois.SelectedIndex+1)
    {
     string sNom = (string)oDS.Tables[0].Rows[i]["NOM"];
     string sDN = tJours[(int)dt.DayOfWeek] + " " + dt.Day + " " + tMois[dt.Month-1] + " " + dt.Year;
     lbPers.Items.Add(sNom + " : " + sDN);
    }
   }
  }

  private void bRechNom_Click(object sender, EventArgs e)
  {
   RechercheSurNom();
  }

  private void RechercheSurNom()
  {
   int N = oDS.Tables[0].Rows.Count;        // Nombre d'enregistrements
   lbPers.Items.Clear();
   string sRech = zePremLettres.Text.ToUpper();
   for (int i = 0; i < N; i++)
   {
    string sNom = (string)oDS.Tables[0].Rows[i]["NOM"];
    string sNomUpper = sNom.ToUpper();
    if (sNomUpper.StartsWith(sRech))
    {
     DateTime dt = (DateTime)oDS.Tables[0].Rows[i]["DN"];
     string sDN = tJours[(int)dt.DayOfWeek] + " " + dt.Day + " " + tMois[dt.Month - 1] + " " + dt.Year;
     lbPers.Items.Add(sNom + " : " + sDN);
    }
   }
  }

  private void zePremLettres_KeyPress(object sender, KeyPressEventArgs e)
  {
   if (e.KeyChar == 13) RechercheSurNom();
  }
 }
}